=== include/CMakeLists.txt ===
add_subdirectory(ixion)
