=== include/ixion/CMakeLists.txt ===

add_subdirectory(interface)

file(GLOB _HEADERS *.hpp)

install(FILES ${_HEADERS}
    DESTINATION include/ixion-${IXION_API_VERSION}/ixion
)
