=== src/test/CMakeLists.txt ===

add_library(ixion-test STATIC test_global.cpp)
